<?php

class Cart2cart_Login_Auth
{
  private static $_validators;

  /**
   * @return Cart2cart_Login_Auth[]
   */
  public static function getValidators()
  {
    if (self::$_validators === null) {
      $iterator = new DirectoryIterator(__DIR__ . '/Auth');
      foreach ($iterator as $fileInfo) {
        if ($fileInfo->isDot() || $fileInfo->getExtension() != 'php') {
          continue;
        }

        $className = self::class . '_' . $fileInfo->getBasename('.php');
        self::$_validators[$className] = new $className;
      }
    }

    return self::$_validators;
  }

  public function customValidateHash($hash, $password, $salt)
  {
    $hashArr = explode(':', $hash);
    $check = false;
    switch (count($hashArr)) {
      case 1:
        $check = md5($password) === $hash;
      break;
      case 2:
        $check = md5($hashArr[1] . $password) === $hashArr[0];
      break;
    }

    if ($check) {
      return true;
    }

    foreach (self::getValidators() as $validator) {
      if (!method_exists($validator, 'validatePassword')) {
        continue;
      }

      if (call_user_func(array($validator, 'validatePassword'), $hash, $password, (string)$salt)) {
        return true;
      }
    }

    throw new Exception(Mage::helper('customer')->__('Invalid login or password.'));
  }
}