<?php

require_once Mage::getModuleDir('controllers', 'Mage_Customer') . '/AccountController.php';

class Cart2cart_Login_AccountController extends Mage_Customer_AccountController
{
  public function loginPostAction()
  {
    /** Users can't login via Chrome */
    //if (!$this->_validateFormKey()) {
    //  $this->_redirect('*/*/');
    //  return;
    //}

    if ($this->_getSession()->isLoggedIn()) {
      $this->_redirect('*/*/');
      return;
    }

    if ($this->getRequest()->isPost()) {

      $session = $this->_getSession();
      $login = $this->getRequest()->getPost('login');

      if (!empty($login['username']) && !empty($login['password'])) {

        $customer = $session->getCustomer()->loadByEmail($login['username']);

        try {

          if (!$customer->getEmail()) {
            throw new Exception($this->__('Unregistered user tries to login'));
          }

          $auth = new Cart2cart_Login_Auth();
          $auth->customValidateHash($customer->getPasswordHash(), $login['password'], $customer->getPasswordSalt());

          $customer->setPassword($login['password'])
            ->setPwdValidateMethod('')
            ->save();

          $session->setCustomerAsLoggedIn($customer);
        } catch(Exception $e) {
          $session->addError($e->getMessage());
        }
      } else {
        $session->addError($this->__('Login and password are required'));
      }
    }

    $this->_loginPostRedirect();
  }
}